package ProjectElectricLocomotive.src.Drawnings;

import ProjectElectricLocomotive.src.Entities.EntityElectricLocomotive;

import java.awt.*;
import java.util.Random;

public class DrawingElectricLocomotive extends DrawingLocomotive
{

    public IDrawingOrnament _ornament;

    public DrawingElectricLocomotive(int speed, float weight, Color bodyColor, Color additionalColor, boolean electricHorns, boolean batteryPlacement)
    {
        super(83,45);
        _entityLocomotive = new EntityElectricLocomotive(speed, weight, bodyColor, additionalColor, electricHorns, batteryPlacement);
        Random rnd = new Random();
        int varOrnament = rnd.nextInt(3);

        switch (varOrnament)
        {
            case 0:
                _ornament = new DrawingOrnamentWheels();
                break;
            case 1:
                _ornament = new DrawningSecondOrnamentWheels();
                break;
            default:
                _ornament = new DrawingWheels();
                break;
        }
        _ornament.SetCountWheels(rnd.nextInt(1,5));
    }
    @Override
    public void DrawTransport(Graphics g)
    {
        if (!(_entityLocomotive instanceof EntityElectricLocomotive _entityElectricLocomotive) || _startPosX == null) return;

        super.DrawTransport(g);

        g.setColor(Color.white);
        g.fillRect(_startPosX + 48, _startPosY + 38, 20, 10);
        g.fillRect(_startPosX + 9, _startPosY + 38, 20, 10);

        // Создание перьев и кистей для прорисовки электровоза
        Color blackColor = Color.BLACK;
        Color deepSkyBlueColor = new Color(0, 191, 255);
        Color yellowColor = Color.YELLOW;

        if (_entityElectricLocomotive.GetElectricHorns()) {
            // Инициализация опорных точек для прорисовки "рогов"
            Point pointHorns1 = new Point(_startPosX + 13, _startPosY + 5);
            Point pointHorns2 = new Point(_startPosX + 16, _startPosY + 2);
            Point pointHorns3 = new Point(_startPosX + 11, _startPosY);

            g.setColor(_entityElectricLocomotive.GetAdditionalColor());

            // Прорисовка "рогов" электровоза
            g.drawLine(pointHorns1.x, pointHorns1.y, pointHorns2.x, pointHorns2.y);
            g.drawLine(pointHorns2.x, pointHorns2.y, pointHorns3.x, pointHorns3.y);

            g.setColor(blackColor);
        }

        if (_entityElectricLocomotive.GetBatteryPlacement()) {
            // Инициализация опорных точек для прорисовки молнии на хранилище батарей
            Point pointLightning1 = new Point(_startPosX + 39, _startPosY + 37);
            Point pointLightning2 = new Point(_startPosX + 37, _startPosY + 39);
            Point pointLightning3 = new Point(_startPosX + 39, _startPosY + 40);
            Point pointLightning4 = new Point(_startPosX + 37, _startPosY + 41);

            g.setColor(_entityElectricLocomotive.GetAdditionalColor());

            // Прорисовка "хранилища батарей" электровоза


            g.fillRect(_startPosX.intValue() + 36, _startPosY + 37, 8, 4);
            g.setColor(yellowColor);
            g.drawLine(pointLightning1.x, pointLightning1.y, pointLightning2.x, pointLightning2.y);
            g.drawLine(pointLightning2.x, pointLightning2.y, pointLightning3.x, pointLightning3.y);
            g.drawLine(pointLightning3.x, pointLightning3.y, pointLightning4.x, pointLightning4.y);
        }

        _ornament.DrawWheels(g, _startPosX, _startPosY);

    }


}
