package ProjectElectricLocomotive.src.Drawnings;


import ProjectElectricLocomotive.src.DirectionType;
import ProjectElectricLocomotive.src.Drawnings.DrawingElectricLocomotive;
import ProjectElectricLocomotive.src.FormElectricLocomotive;
import ProjectElectricLocomotive.src.MovementStrategy.*;

import javax.swing.*;
import java.awt.*;
import java.util.Random;

public class DrawingField  extends JPanel {
    private final FormElectricLocomotive field;
    DrawingLocomotive _drawingLocomotive;
    private AbstractStrategy _strategy = null;
    public DrawingField(FormElectricLocomotive field) {
        this.field = field;
    }
    @Override
    protected void paintComponent(Graphics g)
    {
        if (_drawingLocomotive == null) return;
        _drawingLocomotive.DrawTransport(g);
    }
    public void UpButtonAction()
    {
        if (_drawingLocomotive == null) return;
        _drawingLocomotive.MoveTransport(DirectionType.Up);
    }
    public void DownButtonAction()
    {
        if (_drawingLocomotive == null) return;
        _drawingLocomotive.MoveTransport(DirectionType.Down);
    }
    public void RightButtonAction()
    {
        if (_drawingLocomotive == null) return;
        _drawingLocomotive.MoveTransport(DirectionType.Right);
    }
    public void LeftButtonAction()
    {
        if (_drawingLocomotive == null) return;
        _drawingLocomotive.MoveTransport(DirectionType.Left);
    }
    public void CreateObject(String type){
        Random rnd = new Random();
        switch (type)
        {
            case "DrawningLocomotive":
                _drawingLocomotive = new DrawingLocomotive(rnd.nextInt(100, 300),
                        rnd.nextInt(1000, 3000),
                        new Color(rnd.nextInt(256), rnd.nextInt(256), rnd.nextInt(256)));
                break;
            case "DrawningElectricLocomotive":
                _drawingLocomotive = new DrawingElectricLocomotive(rnd.nextInt(100, 300),
                        rnd.nextInt(1000, 3000),
                        new Color(rnd.nextInt(256), rnd.nextInt(256), rnd.nextInt(256)),
                        new Color(rnd.nextInt(256), rnd.nextInt(256), rnd.nextInt(256)),
                        rnd.nextBoolean(),
                        rnd.nextBoolean());
                break;
            default:
                return;
        }
        _drawingLocomotive.SetPictureSize(getWidth(),getHeight());
        _drawingLocomotive.SetPosition(rnd.nextInt(10, 100), rnd.nextInt(10, 100));
    }

    public void CreateButtonElectricLocomotiveAction(){
        CreateObject("DrawningElectricLocomotive");
    }
    public void CreateButtonLocomotiveAction(){
        CreateObject("DrawningLocomotive");
    }

    public void ButtonStrategyStepAction()
    {
        if(_drawingLocomotive == null) return;
        if (field.comboBoxStrategy.isEnabled())
        {
            int selectedIndex = field.comboBoxStrategy.getSelectedIndex();
            switch (selectedIndex) {
                case 0:
                    _strategy = new MoveToCenter();
                    break;
                case 1:
                    _strategy = new MoveToBorder();
                    break;
                default:
                    _strategy = null;
            }
            if(_strategy == null) return;
            _strategy.SetData(new MoveableLocomotive(_drawingLocomotive), getWidth(), getHeight());
        }
        if (_strategy == null) return;
        field.comboBoxStrategy.setEnabled(false);
        _strategy.MakeStep();

        if(_strategy.getStatus() == StrategyStatus.Finish)
        {
            field.comboBoxStrategy.setEnabled(true);
            _strategy = null;
        }
    }

    public void ResizeField(){
        if (_drawingLocomotive == null) return;
        _drawingLocomotive.SetPictureSize(getWidth(),getHeight());
    }
}
