package ProjectElectricLocomotive.src;

import ProjectElectricLocomotive.src.Drawnings.DrawingField;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;

public class FormElectricLocomotive extends JFrame{
    private int Width;
    private int Height;

    JPanel BottomPanel = new JPanel();
    JPanel CreatePanel = new JPanel();
    JPanel BottomAndCreatePanel = new JPanel();
    JPanel DimPanel = new JPanel();
    JPanel UPanel = new JPanel();
    JPanel DPanel = new JPanel();
    JPanel LRPanel = new JPanel();

    JPanel CBPanel = new JPanel();
    JPanel CPBandButtonPanel = new JPanel();

    DrawingField field = new DrawingField(this);

    JButton ButtonStep = new JButton("Шаг");

    JButton ButtonCreateElectricLocomotive=new JButton("CreateElectricLocomotive");
    JButton ButtonCreateLocomotive=new JButton("CreateLocomotive");

    public JComboBox<String> comboBoxStrategy = new JComboBox<>();

    JButton ButtonUp=new JButton("Up");


    JButton ButtonDown=new JButton("Down");


    JButton ButtonRight=new JButton("Right");

    JButton ButtonLeft=new JButton("Left");
    public FormElectricLocomotive(){
        super("Electric Locomotive");
        setSize(900,500);
        Width = getWidth();
        Height = getHeight();
        setBackground(Color.WHITE);
        ShowWindow();
        RefreshWindow();
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setVisible(true);
    }

    public void ShowWindow(){

        Dimension dimen = new Dimension(30,30);

        ButtonUp.setPreferredSize(dimen);
        ButtonUp.addActionListener(e->{
            field.UpButtonAction();
            repaint();
        });

        ButtonDown.setPreferredSize(dimen);
        ButtonDown.addActionListener(e->{
            field.DownButtonAction();
            repaint();
        });

        ButtonRight.setPreferredSize(dimen);
        ButtonRight.addActionListener(e->{
            field.RightButtonAction();
            repaint();
        });

        ButtonLeft.setPreferredSize(dimen);
        ButtonLeft.addActionListener(e->{
            field.LeftButtonAction();
            repaint();
        });

        LRPanel.setLayout(new FlowLayout(FlowLayout.CENTER,50,0));
        LRPanel.setBackground(new Color(0,0,0,0));
        LRPanel.add(ButtonLeft);
        LRPanel.add(ButtonRight);

        UPanel.setLayout(new FlowLayout());
        UPanel.setBackground(new Color(0,0,0,0));
        UPanel.add(ButtonUp);

        DPanel.setLayout(new FlowLayout());
        DPanel.setBackground(new Color(0,0,0,0));
        DPanel.add(ButtonDown);

        DimPanel.setLayout(new BoxLayout(DimPanel,BoxLayout.Y_AXIS));
        DimPanel.setBackground(new Color(0,0,0,0));
        DimPanel.add(UPanel);
        DimPanel.add(LRPanel);
        DimPanel.add(DPanel);
        add(DimPanel);

        CreatePanel.setLayout(new FlowLayout());
        CreatePanel.setBackground(new Color(0,0,0,0));

        CreatePanel.add(ButtonCreateLocomotive);
        ButtonCreateLocomotive.addActionListener(e->{
            field.CreateButtonLocomotiveAction();
            repaint();
        });

        CreatePanel.add(ButtonCreateElectricLocomotive);
        ButtonCreateElectricLocomotive.addActionListener(e->{
            field.CreateButtonElectricLocomotiveAction();
            repaint();
        });
        comboBoxStrategy.setPreferredSize(new Dimension(80, 40));
        comboBoxStrategy.addItem("К центру");
        comboBoxStrategy.addItem("К краю");
        ButtonStep.setPreferredSize(new Dimension(80, 40));
        ButtonStep.addActionListener(e->{
            field.ButtonStrategyStepAction();
            repaint();
        });

        CBPanel.setLayout(new FlowLayout());
        CBPanel.setBackground(new Color(0, 0, 0, 0));
        CBPanel.add(comboBoxStrategy);
        CBPanel.add(ButtonStep);
        CPBandButtonPanel.setLayout(new BoxLayout(CPBandButtonPanel, BoxLayout.X_AXIS));
        CPBandButtonPanel.setBackground(new Color(0, 0, 0, 0));
        CPBandButtonPanel.add(CBPanel);
        add(CPBandButtonPanel);

        BottomAndCreatePanel.setLayout(new BoxLayout(BottomAndCreatePanel, BoxLayout.Y_AXIS));
        BottomAndCreatePanel.setBackground(new Color(0,0,0,0));
        BottomAndCreatePanel.add(CreatePanel);
        BottomAndCreatePanel.add(BottomPanel);

        add(BottomAndCreatePanel);
        add(field);

        addComponentListener(new ComponentAdapter() {
            @Override
            public void componentResized(ComponentEvent e) {
                super.componentResized(e);
                Width = getWidth();
                Height = getHeight();
                field.ResizeField();
                repaint();
                RefreshWindow();

            }
        });
    }
    public void RefreshWindow(){
        field.setLayout(new FlowLayout());
        CPBandButtonPanel.setBounds(Width - 200, 0, 190, 140);
        BottomAndCreatePanel.setBounds(-330, Height - 110, Width, 180);
        DimPanel.setBounds(Width - 170, Height - 170, 190, 140);
    }
}
